/* tslint:disable */
/* eslint-disable */
/**
 * Halo Next API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import type { Configuration } from '../configuration';
import type { AxiosPromise, AxiosInstance, RawAxiosRequestConfig } from 'axios';
import globalAxios from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError, operationServerMap } from '../base';
// @ts-ignore
import { EmailConfigValidationRequest } from '../models';
/**
 * ConsoleApiNotificationHaloRunV1alpha1NotifierApi - axios parameter creator
 * @export
 */
export const ConsoleApiNotificationHaloRunV1alpha1NotifierApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * Verify email sender config.
         * @param {EmailConfigValidationRequest} emailConfigValidationRequest 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        verifyEmailSenderConfig: async (emailConfigValidationRequest: EmailConfigValidationRequest, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'emailConfigValidationRequest' is not null or undefined
            assertParamExists('verifyEmailSenderConfig', 'emailConfigValidationRequest', emailConfigValidationRequest)
            const localVarPath = `/apis/console.api.notification.halo.run/v1alpha1/notifiers/default-email-notifier/verify-connection`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication BasicAuth required
            // http basic authentication required
            setBasicAuthToObject(localVarRequestOptions, configuration)

            // authentication BearerAuth required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(emailConfigValidationRequest, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * ConsoleApiNotificationHaloRunV1alpha1NotifierApi - functional programming interface
 * @export
 */
export const ConsoleApiNotificationHaloRunV1alpha1NotifierApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = ConsoleApiNotificationHaloRunV1alpha1NotifierApiAxiosParamCreator(configuration)
    return {
        /**
         * Verify email sender config.
         * @param {EmailConfigValidationRequest} emailConfigValidationRequest 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async verifyEmailSenderConfig(emailConfigValidationRequest: EmailConfigValidationRequest, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.verifyEmailSenderConfig(emailConfigValidationRequest, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ConsoleApiNotificationHaloRunV1alpha1NotifierApi.verifyEmailSenderConfig']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
    }
};

/**
 * ConsoleApiNotificationHaloRunV1alpha1NotifierApi - factory interface
 * @export
 */
export const ConsoleApiNotificationHaloRunV1alpha1NotifierApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = ConsoleApiNotificationHaloRunV1alpha1NotifierApiFp(configuration)
    return {
        /**
         * Verify email sender config.
         * @param {ConsoleApiNotificationHaloRunV1alpha1NotifierApiVerifyEmailSenderConfigRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        verifyEmailSenderConfig(requestParameters: ConsoleApiNotificationHaloRunV1alpha1NotifierApiVerifyEmailSenderConfigRequest, options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.verifyEmailSenderConfig(requestParameters.emailConfigValidationRequest, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for verifyEmailSenderConfig operation in ConsoleApiNotificationHaloRunV1alpha1NotifierApi.
 * @export
 * @interface ConsoleApiNotificationHaloRunV1alpha1NotifierApiVerifyEmailSenderConfigRequest
 */
export interface ConsoleApiNotificationHaloRunV1alpha1NotifierApiVerifyEmailSenderConfigRequest {
    /**
     * 
     * @type {EmailConfigValidationRequest}
     * @memberof ConsoleApiNotificationHaloRunV1alpha1NotifierApiVerifyEmailSenderConfig
     */
    readonly emailConfigValidationRequest: EmailConfigValidationRequest
}

/**
 * ConsoleApiNotificationHaloRunV1alpha1NotifierApi - object-oriented interface
 * @export
 * @class ConsoleApiNotificationHaloRunV1alpha1NotifierApi
 * @extends {BaseAPI}
 */
export class ConsoleApiNotificationHaloRunV1alpha1NotifierApi extends BaseAPI {
    /**
     * Verify email sender config.
     * @param {ConsoleApiNotificationHaloRunV1alpha1NotifierApiVerifyEmailSenderConfigRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ConsoleApiNotificationHaloRunV1alpha1NotifierApi
     */
    public verifyEmailSenderConfig(requestParameters: ConsoleApiNotificationHaloRunV1alpha1NotifierApiVerifyEmailSenderConfigRequest, options?: RawAxiosRequestConfig) {
        return ConsoleApiNotificationHaloRunV1alpha1NotifierApiFp(this.configuration).verifyEmailSenderConfig(requestParameters.emailConfigValidationRequest, options).then((request) => request(this.axios, this.basePath));
    }
}

