/* tslint:disable */
/* eslint-disable */
/**
 * Halo Next API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import type { Configuration } from '../configuration';
import type { AxiosPromise, AxiosInstance, RawAxiosRequestConfig } from 'axios';
import globalAxios from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError, operationServerMap } from '../base';
// @ts-ignore
import { Subscription } from '../models';
// @ts-ignore
import { SubscriptionList } from '../models';
/**
 * NotificationHaloRunV1alpha1SubscriptionApi - axios parameter creator
 * @export
 */
export const NotificationHaloRunV1alpha1SubscriptionApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * Create notification.halo.run/v1alpha1/Subscription
         * @param {Subscription} [subscription] Fresh subscription
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createnotificationHaloRunV1alpha1Subscription: async (subscription?: Subscription, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/apis/notification.halo.run/v1alpha1/subscriptions`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication BasicAuth required
            // http basic authentication required
            setBasicAuthToObject(localVarRequestOptions, configuration)

            // authentication BearerAuth required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(subscription, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Delete notification.halo.run/v1alpha1/Subscription
         * @param {string} name Name of subscription
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deletenotificationHaloRunV1alpha1Subscription: async (name: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'name' is not null or undefined
            assertParamExists('deletenotificationHaloRunV1alpha1Subscription', 'name', name)
            const localVarPath = `/apis/notification.halo.run/v1alpha1/subscriptions/{name}`
                .replace(`{${"name"}}`, encodeURIComponent(String(name)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication BasicAuth required
            // http basic authentication required
            setBasicAuthToObject(localVarRequestOptions, configuration)

            // authentication BearerAuth required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Get notification.halo.run/v1alpha1/Subscription
         * @param {string} name Name of subscription
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getnotificationHaloRunV1alpha1Subscription: async (name: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'name' is not null or undefined
            assertParamExists('getnotificationHaloRunV1alpha1Subscription', 'name', name)
            const localVarPath = `/apis/notification.halo.run/v1alpha1/subscriptions/{name}`
                .replace(`{${"name"}}`, encodeURIComponent(String(name)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication BasicAuth required
            // http basic authentication required
            setBasicAuthToObject(localVarRequestOptions, configuration)

            // authentication BearerAuth required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * List notification.halo.run/v1alpha1/Subscription
         * @param {number} [page] Page number. Default is 0.
         * @param {number} [size] Size number. Default is 0.
         * @param {Array<string>} [labelSelector] Label selector. e.g.: hidden!&#x3D;true
         * @param {Array<string>} [fieldSelector] Field selector. e.g.: metadata.name&#x3D;&#x3D;halo
         * @param {Array<string>} [sort] Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        listnotificationHaloRunV1alpha1Subscription: async (page?: number, size?: number, labelSelector?: Array<string>, fieldSelector?: Array<string>, sort?: Array<string>, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/apis/notification.halo.run/v1alpha1/subscriptions`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication BasicAuth required
            // http basic authentication required
            setBasicAuthToObject(localVarRequestOptions, configuration)

            // authentication BearerAuth required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (size !== undefined) {
                localVarQueryParameter['size'] = size;
            }

            if (labelSelector) {
                localVarQueryParameter['labelSelector'] = labelSelector;
            }

            if (fieldSelector) {
                localVarQueryParameter['fieldSelector'] = fieldSelector;
            }

            if (sort) {
                localVarQueryParameter['sort'] = sort;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Update notification.halo.run/v1alpha1/Subscription
         * @param {string} name Name of subscription
         * @param {Subscription} [subscription] Updated subscription
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updatenotificationHaloRunV1alpha1Subscription: async (name: string, subscription?: Subscription, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'name' is not null or undefined
            assertParamExists('updatenotificationHaloRunV1alpha1Subscription', 'name', name)
            const localVarPath = `/apis/notification.halo.run/v1alpha1/subscriptions/{name}`
                .replace(`{${"name"}}`, encodeURIComponent(String(name)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication BasicAuth required
            // http basic authentication required
            setBasicAuthToObject(localVarRequestOptions, configuration)

            // authentication BearerAuth required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(subscription, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * NotificationHaloRunV1alpha1SubscriptionApi - functional programming interface
 * @export
 */
export const NotificationHaloRunV1alpha1SubscriptionApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = NotificationHaloRunV1alpha1SubscriptionApiAxiosParamCreator(configuration)
    return {
        /**
         * Create notification.halo.run/v1alpha1/Subscription
         * @param {Subscription} [subscription] Fresh subscription
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async createnotificationHaloRunV1alpha1Subscription(subscription?: Subscription, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Subscription>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.createnotificationHaloRunV1alpha1Subscription(subscription, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['NotificationHaloRunV1alpha1SubscriptionApi.createnotificationHaloRunV1alpha1Subscription']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * Delete notification.halo.run/v1alpha1/Subscription
         * @param {string} name Name of subscription
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async deletenotificationHaloRunV1alpha1Subscription(name: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.deletenotificationHaloRunV1alpha1Subscription(name, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['NotificationHaloRunV1alpha1SubscriptionApi.deletenotificationHaloRunV1alpha1Subscription']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * Get notification.halo.run/v1alpha1/Subscription
         * @param {string} name Name of subscription
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getnotificationHaloRunV1alpha1Subscription(name: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Subscription>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getnotificationHaloRunV1alpha1Subscription(name, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['NotificationHaloRunV1alpha1SubscriptionApi.getnotificationHaloRunV1alpha1Subscription']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * List notification.halo.run/v1alpha1/Subscription
         * @param {number} [page] Page number. Default is 0.
         * @param {number} [size] Size number. Default is 0.
         * @param {Array<string>} [labelSelector] Label selector. e.g.: hidden!&#x3D;true
         * @param {Array<string>} [fieldSelector] Field selector. e.g.: metadata.name&#x3D;&#x3D;halo
         * @param {Array<string>} [sort] Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async listnotificationHaloRunV1alpha1Subscription(page?: number, size?: number, labelSelector?: Array<string>, fieldSelector?: Array<string>, sort?: Array<string>, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SubscriptionList>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.listnotificationHaloRunV1alpha1Subscription(page, size, labelSelector, fieldSelector, sort, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['NotificationHaloRunV1alpha1SubscriptionApi.listnotificationHaloRunV1alpha1Subscription']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * Update notification.halo.run/v1alpha1/Subscription
         * @param {string} name Name of subscription
         * @param {Subscription} [subscription] Updated subscription
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async updatenotificationHaloRunV1alpha1Subscription(name: string, subscription?: Subscription, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Subscription>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.updatenotificationHaloRunV1alpha1Subscription(name, subscription, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['NotificationHaloRunV1alpha1SubscriptionApi.updatenotificationHaloRunV1alpha1Subscription']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
    }
};

/**
 * NotificationHaloRunV1alpha1SubscriptionApi - factory interface
 * @export
 */
export const NotificationHaloRunV1alpha1SubscriptionApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = NotificationHaloRunV1alpha1SubscriptionApiFp(configuration)
    return {
        /**
         * Create notification.halo.run/v1alpha1/Subscription
         * @param {NotificationHaloRunV1alpha1SubscriptionApiCreatenotificationHaloRunV1alpha1SubscriptionRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createnotificationHaloRunV1alpha1Subscription(requestParameters: NotificationHaloRunV1alpha1SubscriptionApiCreatenotificationHaloRunV1alpha1SubscriptionRequest = {}, options?: RawAxiosRequestConfig): AxiosPromise<Subscription> {
            return localVarFp.createnotificationHaloRunV1alpha1Subscription(requestParameters.subscription, options).then((request) => request(axios, basePath));
        },
        /**
         * Delete notification.halo.run/v1alpha1/Subscription
         * @param {NotificationHaloRunV1alpha1SubscriptionApiDeletenotificationHaloRunV1alpha1SubscriptionRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deletenotificationHaloRunV1alpha1Subscription(requestParameters: NotificationHaloRunV1alpha1SubscriptionApiDeletenotificationHaloRunV1alpha1SubscriptionRequest, options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.deletenotificationHaloRunV1alpha1Subscription(requestParameters.name, options).then((request) => request(axios, basePath));
        },
        /**
         * Get notification.halo.run/v1alpha1/Subscription
         * @param {NotificationHaloRunV1alpha1SubscriptionApiGetnotificationHaloRunV1alpha1SubscriptionRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getnotificationHaloRunV1alpha1Subscription(requestParameters: NotificationHaloRunV1alpha1SubscriptionApiGetnotificationHaloRunV1alpha1SubscriptionRequest, options?: RawAxiosRequestConfig): AxiosPromise<Subscription> {
            return localVarFp.getnotificationHaloRunV1alpha1Subscription(requestParameters.name, options).then((request) => request(axios, basePath));
        },
        /**
         * List notification.halo.run/v1alpha1/Subscription
         * @param {NotificationHaloRunV1alpha1SubscriptionApiListnotificationHaloRunV1alpha1SubscriptionRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        listnotificationHaloRunV1alpha1Subscription(requestParameters: NotificationHaloRunV1alpha1SubscriptionApiListnotificationHaloRunV1alpha1SubscriptionRequest = {}, options?: RawAxiosRequestConfig): AxiosPromise<SubscriptionList> {
            return localVarFp.listnotificationHaloRunV1alpha1Subscription(requestParameters.page, requestParameters.size, requestParameters.labelSelector, requestParameters.fieldSelector, requestParameters.sort, options).then((request) => request(axios, basePath));
        },
        /**
         * Update notification.halo.run/v1alpha1/Subscription
         * @param {NotificationHaloRunV1alpha1SubscriptionApiUpdatenotificationHaloRunV1alpha1SubscriptionRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updatenotificationHaloRunV1alpha1Subscription(requestParameters: NotificationHaloRunV1alpha1SubscriptionApiUpdatenotificationHaloRunV1alpha1SubscriptionRequest, options?: RawAxiosRequestConfig): AxiosPromise<Subscription> {
            return localVarFp.updatenotificationHaloRunV1alpha1Subscription(requestParameters.name, requestParameters.subscription, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for createnotificationHaloRunV1alpha1Subscription operation in NotificationHaloRunV1alpha1SubscriptionApi.
 * @export
 * @interface NotificationHaloRunV1alpha1SubscriptionApiCreatenotificationHaloRunV1alpha1SubscriptionRequest
 */
export interface NotificationHaloRunV1alpha1SubscriptionApiCreatenotificationHaloRunV1alpha1SubscriptionRequest {
    /**
     * Fresh subscription
     * @type {Subscription}
     * @memberof NotificationHaloRunV1alpha1SubscriptionApiCreatenotificationHaloRunV1alpha1Subscription
     */
    readonly subscription?: Subscription
}

/**
 * Request parameters for deletenotificationHaloRunV1alpha1Subscription operation in NotificationHaloRunV1alpha1SubscriptionApi.
 * @export
 * @interface NotificationHaloRunV1alpha1SubscriptionApiDeletenotificationHaloRunV1alpha1SubscriptionRequest
 */
export interface NotificationHaloRunV1alpha1SubscriptionApiDeletenotificationHaloRunV1alpha1SubscriptionRequest {
    /**
     * Name of subscription
     * @type {string}
     * @memberof NotificationHaloRunV1alpha1SubscriptionApiDeletenotificationHaloRunV1alpha1Subscription
     */
    readonly name: string
}

/**
 * Request parameters for getnotificationHaloRunV1alpha1Subscription operation in NotificationHaloRunV1alpha1SubscriptionApi.
 * @export
 * @interface NotificationHaloRunV1alpha1SubscriptionApiGetnotificationHaloRunV1alpha1SubscriptionRequest
 */
export interface NotificationHaloRunV1alpha1SubscriptionApiGetnotificationHaloRunV1alpha1SubscriptionRequest {
    /**
     * Name of subscription
     * @type {string}
     * @memberof NotificationHaloRunV1alpha1SubscriptionApiGetnotificationHaloRunV1alpha1Subscription
     */
    readonly name: string
}

/**
 * Request parameters for listnotificationHaloRunV1alpha1Subscription operation in NotificationHaloRunV1alpha1SubscriptionApi.
 * @export
 * @interface NotificationHaloRunV1alpha1SubscriptionApiListnotificationHaloRunV1alpha1SubscriptionRequest
 */
export interface NotificationHaloRunV1alpha1SubscriptionApiListnotificationHaloRunV1alpha1SubscriptionRequest {
    /**
     * Page number. Default is 0.
     * @type {number}
     * @memberof NotificationHaloRunV1alpha1SubscriptionApiListnotificationHaloRunV1alpha1Subscription
     */
    readonly page?: number

    /**
     * Size number. Default is 0.
     * @type {number}
     * @memberof NotificationHaloRunV1alpha1SubscriptionApiListnotificationHaloRunV1alpha1Subscription
     */
    readonly size?: number

    /**
     * Label selector. e.g.: hidden!&#x3D;true
     * @type {Array<string>}
     * @memberof NotificationHaloRunV1alpha1SubscriptionApiListnotificationHaloRunV1alpha1Subscription
     */
    readonly labelSelector?: Array<string>

    /**
     * Field selector. e.g.: metadata.name&#x3D;&#x3D;halo
     * @type {Array<string>}
     * @memberof NotificationHaloRunV1alpha1SubscriptionApiListnotificationHaloRunV1alpha1Subscription
     */
    readonly fieldSelector?: Array<string>

    /**
     * Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
     * @type {Array<string>}
     * @memberof NotificationHaloRunV1alpha1SubscriptionApiListnotificationHaloRunV1alpha1Subscription
     */
    readonly sort?: Array<string>
}

/**
 * Request parameters for updatenotificationHaloRunV1alpha1Subscription operation in NotificationHaloRunV1alpha1SubscriptionApi.
 * @export
 * @interface NotificationHaloRunV1alpha1SubscriptionApiUpdatenotificationHaloRunV1alpha1SubscriptionRequest
 */
export interface NotificationHaloRunV1alpha1SubscriptionApiUpdatenotificationHaloRunV1alpha1SubscriptionRequest {
    /**
     * Name of subscription
     * @type {string}
     * @memberof NotificationHaloRunV1alpha1SubscriptionApiUpdatenotificationHaloRunV1alpha1Subscription
     */
    readonly name: string

    /**
     * Updated subscription
     * @type {Subscription}
     * @memberof NotificationHaloRunV1alpha1SubscriptionApiUpdatenotificationHaloRunV1alpha1Subscription
     */
    readonly subscription?: Subscription
}

/**
 * NotificationHaloRunV1alpha1SubscriptionApi - object-oriented interface
 * @export
 * @class NotificationHaloRunV1alpha1SubscriptionApi
 * @extends {BaseAPI}
 */
export class NotificationHaloRunV1alpha1SubscriptionApi extends BaseAPI {
    /**
     * Create notification.halo.run/v1alpha1/Subscription
     * @param {NotificationHaloRunV1alpha1SubscriptionApiCreatenotificationHaloRunV1alpha1SubscriptionRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof NotificationHaloRunV1alpha1SubscriptionApi
     */
    public createnotificationHaloRunV1alpha1Subscription(requestParameters: NotificationHaloRunV1alpha1SubscriptionApiCreatenotificationHaloRunV1alpha1SubscriptionRequest = {}, options?: RawAxiosRequestConfig) {
        return NotificationHaloRunV1alpha1SubscriptionApiFp(this.configuration).createnotificationHaloRunV1alpha1Subscription(requestParameters.subscription, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * Delete notification.halo.run/v1alpha1/Subscription
     * @param {NotificationHaloRunV1alpha1SubscriptionApiDeletenotificationHaloRunV1alpha1SubscriptionRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof NotificationHaloRunV1alpha1SubscriptionApi
     */
    public deletenotificationHaloRunV1alpha1Subscription(requestParameters: NotificationHaloRunV1alpha1SubscriptionApiDeletenotificationHaloRunV1alpha1SubscriptionRequest, options?: RawAxiosRequestConfig) {
        return NotificationHaloRunV1alpha1SubscriptionApiFp(this.configuration).deletenotificationHaloRunV1alpha1Subscription(requestParameters.name, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * Get notification.halo.run/v1alpha1/Subscription
     * @param {NotificationHaloRunV1alpha1SubscriptionApiGetnotificationHaloRunV1alpha1SubscriptionRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof NotificationHaloRunV1alpha1SubscriptionApi
     */
    public getnotificationHaloRunV1alpha1Subscription(requestParameters: NotificationHaloRunV1alpha1SubscriptionApiGetnotificationHaloRunV1alpha1SubscriptionRequest, options?: RawAxiosRequestConfig) {
        return NotificationHaloRunV1alpha1SubscriptionApiFp(this.configuration).getnotificationHaloRunV1alpha1Subscription(requestParameters.name, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * List notification.halo.run/v1alpha1/Subscription
     * @param {NotificationHaloRunV1alpha1SubscriptionApiListnotificationHaloRunV1alpha1SubscriptionRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof NotificationHaloRunV1alpha1SubscriptionApi
     */
    public listnotificationHaloRunV1alpha1Subscription(requestParameters: NotificationHaloRunV1alpha1SubscriptionApiListnotificationHaloRunV1alpha1SubscriptionRequest = {}, options?: RawAxiosRequestConfig) {
        return NotificationHaloRunV1alpha1SubscriptionApiFp(this.configuration).listnotificationHaloRunV1alpha1Subscription(requestParameters.page, requestParameters.size, requestParameters.labelSelector, requestParameters.fieldSelector, requestParameters.sort, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * Update notification.halo.run/v1alpha1/Subscription
     * @param {NotificationHaloRunV1alpha1SubscriptionApiUpdatenotificationHaloRunV1alpha1SubscriptionRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof NotificationHaloRunV1alpha1SubscriptionApi
     */
    public updatenotificationHaloRunV1alpha1Subscription(requestParameters: NotificationHaloRunV1alpha1SubscriptionApiUpdatenotificationHaloRunV1alpha1SubscriptionRequest, options?: RawAxiosRequestConfig) {
        return NotificationHaloRunV1alpha1SubscriptionApiFp(this.configuration).updatenotificationHaloRunV1alpha1Subscription(requestParameters.name, requestParameters.subscription, options).then((request) => request(this.axios, this.basePath));
    }
}

