/* tslint:disable */
/* eslint-disable */
/**
 * Halo Next API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import type { Configuration } from '../configuration';
import type { AxiosPromise, AxiosInstance, RawAxiosRequestConfig } from 'axios';
import globalAxios from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError, operationServerMap } from '../base';
// @ts-ignore
import { Group } from '../models';
// @ts-ignore
import { GroupList } from '../models';
/**
 * StorageHaloRunV1alpha1GroupApi - axios parameter creator
 * @export
 */
export const StorageHaloRunV1alpha1GroupApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * Create storage.halo.run/v1alpha1/Group
         * @param {Group} [group] Fresh group
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createstorageHaloRunV1alpha1Group: async (group?: Group, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/apis/storage.halo.run/v1alpha1/groups`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication BasicAuth required
            // http basic authentication required
            setBasicAuthToObject(localVarRequestOptions, configuration)

            // authentication BearerAuth required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(group, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Delete storage.halo.run/v1alpha1/Group
         * @param {string} name Name of group
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deletestorageHaloRunV1alpha1Group: async (name: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'name' is not null or undefined
            assertParamExists('deletestorageHaloRunV1alpha1Group', 'name', name)
            const localVarPath = `/apis/storage.halo.run/v1alpha1/groups/{name}`
                .replace(`{${"name"}}`, encodeURIComponent(String(name)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication BasicAuth required
            // http basic authentication required
            setBasicAuthToObject(localVarRequestOptions, configuration)

            // authentication BearerAuth required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Get storage.halo.run/v1alpha1/Group
         * @param {string} name Name of group
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getstorageHaloRunV1alpha1Group: async (name: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'name' is not null or undefined
            assertParamExists('getstorageHaloRunV1alpha1Group', 'name', name)
            const localVarPath = `/apis/storage.halo.run/v1alpha1/groups/{name}`
                .replace(`{${"name"}}`, encodeURIComponent(String(name)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication BasicAuth required
            // http basic authentication required
            setBasicAuthToObject(localVarRequestOptions, configuration)

            // authentication BearerAuth required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * List storage.halo.run/v1alpha1/Group
         * @param {number} [page] Page number. Default is 0.
         * @param {number} [size] Size number. Default is 0.
         * @param {Array<string>} [labelSelector] Label selector. e.g.: hidden!&#x3D;true
         * @param {Array<string>} [fieldSelector] Field selector. e.g.: metadata.name&#x3D;&#x3D;halo
         * @param {Array<string>} [sort] Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        liststorageHaloRunV1alpha1Group: async (page?: number, size?: number, labelSelector?: Array<string>, fieldSelector?: Array<string>, sort?: Array<string>, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/apis/storage.halo.run/v1alpha1/groups`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication BasicAuth required
            // http basic authentication required
            setBasicAuthToObject(localVarRequestOptions, configuration)

            // authentication BearerAuth required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (size !== undefined) {
                localVarQueryParameter['size'] = size;
            }

            if (labelSelector) {
                localVarQueryParameter['labelSelector'] = labelSelector;
            }

            if (fieldSelector) {
                localVarQueryParameter['fieldSelector'] = fieldSelector;
            }

            if (sort) {
                localVarQueryParameter['sort'] = sort;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Update storage.halo.run/v1alpha1/Group
         * @param {string} name Name of group
         * @param {Group} [group] Updated group
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updatestorageHaloRunV1alpha1Group: async (name: string, group?: Group, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'name' is not null or undefined
            assertParamExists('updatestorageHaloRunV1alpha1Group', 'name', name)
            const localVarPath = `/apis/storage.halo.run/v1alpha1/groups/{name}`
                .replace(`{${"name"}}`, encodeURIComponent(String(name)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication BasicAuth required
            // http basic authentication required
            setBasicAuthToObject(localVarRequestOptions, configuration)

            // authentication BearerAuth required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(group, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * StorageHaloRunV1alpha1GroupApi - functional programming interface
 * @export
 */
export const StorageHaloRunV1alpha1GroupApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = StorageHaloRunV1alpha1GroupApiAxiosParamCreator(configuration)
    return {
        /**
         * Create storage.halo.run/v1alpha1/Group
         * @param {Group} [group] Fresh group
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async createstorageHaloRunV1alpha1Group(group?: Group, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Group>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.createstorageHaloRunV1alpha1Group(group, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['StorageHaloRunV1alpha1GroupApi.createstorageHaloRunV1alpha1Group']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * Delete storage.halo.run/v1alpha1/Group
         * @param {string} name Name of group
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async deletestorageHaloRunV1alpha1Group(name: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.deletestorageHaloRunV1alpha1Group(name, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['StorageHaloRunV1alpha1GroupApi.deletestorageHaloRunV1alpha1Group']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * Get storage.halo.run/v1alpha1/Group
         * @param {string} name Name of group
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getstorageHaloRunV1alpha1Group(name: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Group>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getstorageHaloRunV1alpha1Group(name, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['StorageHaloRunV1alpha1GroupApi.getstorageHaloRunV1alpha1Group']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * List storage.halo.run/v1alpha1/Group
         * @param {number} [page] Page number. Default is 0.
         * @param {number} [size] Size number. Default is 0.
         * @param {Array<string>} [labelSelector] Label selector. e.g.: hidden!&#x3D;true
         * @param {Array<string>} [fieldSelector] Field selector. e.g.: metadata.name&#x3D;&#x3D;halo
         * @param {Array<string>} [sort] Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async liststorageHaloRunV1alpha1Group(page?: number, size?: number, labelSelector?: Array<string>, fieldSelector?: Array<string>, sort?: Array<string>, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<GroupList>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.liststorageHaloRunV1alpha1Group(page, size, labelSelector, fieldSelector, sort, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['StorageHaloRunV1alpha1GroupApi.liststorageHaloRunV1alpha1Group']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * Update storage.halo.run/v1alpha1/Group
         * @param {string} name Name of group
         * @param {Group} [group] Updated group
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async updatestorageHaloRunV1alpha1Group(name: string, group?: Group, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Group>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.updatestorageHaloRunV1alpha1Group(name, group, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['StorageHaloRunV1alpha1GroupApi.updatestorageHaloRunV1alpha1Group']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
    }
};

/**
 * StorageHaloRunV1alpha1GroupApi - factory interface
 * @export
 */
export const StorageHaloRunV1alpha1GroupApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = StorageHaloRunV1alpha1GroupApiFp(configuration)
    return {
        /**
         * Create storage.halo.run/v1alpha1/Group
         * @param {StorageHaloRunV1alpha1GroupApiCreatestorageHaloRunV1alpha1GroupRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createstorageHaloRunV1alpha1Group(requestParameters: StorageHaloRunV1alpha1GroupApiCreatestorageHaloRunV1alpha1GroupRequest = {}, options?: RawAxiosRequestConfig): AxiosPromise<Group> {
            return localVarFp.createstorageHaloRunV1alpha1Group(requestParameters.group, options).then((request) => request(axios, basePath));
        },
        /**
         * Delete storage.halo.run/v1alpha1/Group
         * @param {StorageHaloRunV1alpha1GroupApiDeletestorageHaloRunV1alpha1GroupRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deletestorageHaloRunV1alpha1Group(requestParameters: StorageHaloRunV1alpha1GroupApiDeletestorageHaloRunV1alpha1GroupRequest, options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.deletestorageHaloRunV1alpha1Group(requestParameters.name, options).then((request) => request(axios, basePath));
        },
        /**
         * Get storage.halo.run/v1alpha1/Group
         * @param {StorageHaloRunV1alpha1GroupApiGetstorageHaloRunV1alpha1GroupRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getstorageHaloRunV1alpha1Group(requestParameters: StorageHaloRunV1alpha1GroupApiGetstorageHaloRunV1alpha1GroupRequest, options?: RawAxiosRequestConfig): AxiosPromise<Group> {
            return localVarFp.getstorageHaloRunV1alpha1Group(requestParameters.name, options).then((request) => request(axios, basePath));
        },
        /**
         * List storage.halo.run/v1alpha1/Group
         * @param {StorageHaloRunV1alpha1GroupApiListstorageHaloRunV1alpha1GroupRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        liststorageHaloRunV1alpha1Group(requestParameters: StorageHaloRunV1alpha1GroupApiListstorageHaloRunV1alpha1GroupRequest = {}, options?: RawAxiosRequestConfig): AxiosPromise<GroupList> {
            return localVarFp.liststorageHaloRunV1alpha1Group(requestParameters.page, requestParameters.size, requestParameters.labelSelector, requestParameters.fieldSelector, requestParameters.sort, options).then((request) => request(axios, basePath));
        },
        /**
         * Update storage.halo.run/v1alpha1/Group
         * @param {StorageHaloRunV1alpha1GroupApiUpdatestorageHaloRunV1alpha1GroupRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updatestorageHaloRunV1alpha1Group(requestParameters: StorageHaloRunV1alpha1GroupApiUpdatestorageHaloRunV1alpha1GroupRequest, options?: RawAxiosRequestConfig): AxiosPromise<Group> {
            return localVarFp.updatestorageHaloRunV1alpha1Group(requestParameters.name, requestParameters.group, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for createstorageHaloRunV1alpha1Group operation in StorageHaloRunV1alpha1GroupApi.
 * @export
 * @interface StorageHaloRunV1alpha1GroupApiCreatestorageHaloRunV1alpha1GroupRequest
 */
export interface StorageHaloRunV1alpha1GroupApiCreatestorageHaloRunV1alpha1GroupRequest {
    /**
     * Fresh group
     * @type {Group}
     * @memberof StorageHaloRunV1alpha1GroupApiCreatestorageHaloRunV1alpha1Group
     */
    readonly group?: Group
}

/**
 * Request parameters for deletestorageHaloRunV1alpha1Group operation in StorageHaloRunV1alpha1GroupApi.
 * @export
 * @interface StorageHaloRunV1alpha1GroupApiDeletestorageHaloRunV1alpha1GroupRequest
 */
export interface StorageHaloRunV1alpha1GroupApiDeletestorageHaloRunV1alpha1GroupRequest {
    /**
     * Name of group
     * @type {string}
     * @memberof StorageHaloRunV1alpha1GroupApiDeletestorageHaloRunV1alpha1Group
     */
    readonly name: string
}

/**
 * Request parameters for getstorageHaloRunV1alpha1Group operation in StorageHaloRunV1alpha1GroupApi.
 * @export
 * @interface StorageHaloRunV1alpha1GroupApiGetstorageHaloRunV1alpha1GroupRequest
 */
export interface StorageHaloRunV1alpha1GroupApiGetstorageHaloRunV1alpha1GroupRequest {
    /**
     * Name of group
     * @type {string}
     * @memberof StorageHaloRunV1alpha1GroupApiGetstorageHaloRunV1alpha1Group
     */
    readonly name: string
}

/**
 * Request parameters for liststorageHaloRunV1alpha1Group operation in StorageHaloRunV1alpha1GroupApi.
 * @export
 * @interface StorageHaloRunV1alpha1GroupApiListstorageHaloRunV1alpha1GroupRequest
 */
export interface StorageHaloRunV1alpha1GroupApiListstorageHaloRunV1alpha1GroupRequest {
    /**
     * Page number. Default is 0.
     * @type {number}
     * @memberof StorageHaloRunV1alpha1GroupApiListstorageHaloRunV1alpha1Group
     */
    readonly page?: number

    /**
     * Size number. Default is 0.
     * @type {number}
     * @memberof StorageHaloRunV1alpha1GroupApiListstorageHaloRunV1alpha1Group
     */
    readonly size?: number

    /**
     * Label selector. e.g.: hidden!&#x3D;true
     * @type {Array<string>}
     * @memberof StorageHaloRunV1alpha1GroupApiListstorageHaloRunV1alpha1Group
     */
    readonly labelSelector?: Array<string>

    /**
     * Field selector. e.g.: metadata.name&#x3D;&#x3D;halo
     * @type {Array<string>}
     * @memberof StorageHaloRunV1alpha1GroupApiListstorageHaloRunV1alpha1Group
     */
    readonly fieldSelector?: Array<string>

    /**
     * Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
     * @type {Array<string>}
     * @memberof StorageHaloRunV1alpha1GroupApiListstorageHaloRunV1alpha1Group
     */
    readonly sort?: Array<string>
}

/**
 * Request parameters for updatestorageHaloRunV1alpha1Group operation in StorageHaloRunV1alpha1GroupApi.
 * @export
 * @interface StorageHaloRunV1alpha1GroupApiUpdatestorageHaloRunV1alpha1GroupRequest
 */
export interface StorageHaloRunV1alpha1GroupApiUpdatestorageHaloRunV1alpha1GroupRequest {
    /**
     * Name of group
     * @type {string}
     * @memberof StorageHaloRunV1alpha1GroupApiUpdatestorageHaloRunV1alpha1Group
     */
    readonly name: string

    /**
     * Updated group
     * @type {Group}
     * @memberof StorageHaloRunV1alpha1GroupApiUpdatestorageHaloRunV1alpha1Group
     */
    readonly group?: Group
}

/**
 * StorageHaloRunV1alpha1GroupApi - object-oriented interface
 * @export
 * @class StorageHaloRunV1alpha1GroupApi
 * @extends {BaseAPI}
 */
export class StorageHaloRunV1alpha1GroupApi extends BaseAPI {
    /**
     * Create storage.halo.run/v1alpha1/Group
     * @param {StorageHaloRunV1alpha1GroupApiCreatestorageHaloRunV1alpha1GroupRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof StorageHaloRunV1alpha1GroupApi
     */
    public createstorageHaloRunV1alpha1Group(requestParameters: StorageHaloRunV1alpha1GroupApiCreatestorageHaloRunV1alpha1GroupRequest = {}, options?: RawAxiosRequestConfig) {
        return StorageHaloRunV1alpha1GroupApiFp(this.configuration).createstorageHaloRunV1alpha1Group(requestParameters.group, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * Delete storage.halo.run/v1alpha1/Group
     * @param {StorageHaloRunV1alpha1GroupApiDeletestorageHaloRunV1alpha1GroupRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof StorageHaloRunV1alpha1GroupApi
     */
    public deletestorageHaloRunV1alpha1Group(requestParameters: StorageHaloRunV1alpha1GroupApiDeletestorageHaloRunV1alpha1GroupRequest, options?: RawAxiosRequestConfig) {
        return StorageHaloRunV1alpha1GroupApiFp(this.configuration).deletestorageHaloRunV1alpha1Group(requestParameters.name, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * Get storage.halo.run/v1alpha1/Group
     * @param {StorageHaloRunV1alpha1GroupApiGetstorageHaloRunV1alpha1GroupRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof StorageHaloRunV1alpha1GroupApi
     */
    public getstorageHaloRunV1alpha1Group(requestParameters: StorageHaloRunV1alpha1GroupApiGetstorageHaloRunV1alpha1GroupRequest, options?: RawAxiosRequestConfig) {
        return StorageHaloRunV1alpha1GroupApiFp(this.configuration).getstorageHaloRunV1alpha1Group(requestParameters.name, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * List storage.halo.run/v1alpha1/Group
     * @param {StorageHaloRunV1alpha1GroupApiListstorageHaloRunV1alpha1GroupRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof StorageHaloRunV1alpha1GroupApi
     */
    public liststorageHaloRunV1alpha1Group(requestParameters: StorageHaloRunV1alpha1GroupApiListstorageHaloRunV1alpha1GroupRequest = {}, options?: RawAxiosRequestConfig) {
        return StorageHaloRunV1alpha1GroupApiFp(this.configuration).liststorageHaloRunV1alpha1Group(requestParameters.page, requestParameters.size, requestParameters.labelSelector, requestParameters.fieldSelector, requestParameters.sort, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * Update storage.halo.run/v1alpha1/Group
     * @param {StorageHaloRunV1alpha1GroupApiUpdatestorageHaloRunV1alpha1GroupRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof StorageHaloRunV1alpha1GroupApi
     */
    public updatestorageHaloRunV1alpha1Group(requestParameters: StorageHaloRunV1alpha1GroupApiUpdatestorageHaloRunV1alpha1GroupRequest, options?: RawAxiosRequestConfig) {
        return StorageHaloRunV1alpha1GroupApiFp(this.configuration).updatestorageHaloRunV1alpha1Group(requestParameters.name, requestParameters.group, options).then((request) => request(this.axios, this.basePath));
    }
}

